# CT2XML.SED
# By L. John Junod
# Last Revised: 05-16-03
# Designed to take ISODraw 5.04 Clear Text and turn it into
# CGMXML-V4.DTD compliant XML
# 
# This script only understands the NIST/OPENCGM WebCGM Test Suite. Copyright (C) 2002, Lofton Henderson. All Rights Reserved.
# Please see accompanying license agreement 'copyright-license.html' for the full details.
#
# The Original WebCGM Test Suite is available at: http://www.nist.gov or from http://www.cgmopen.org
#
# This is Version 0.7 of the script which matches CGMXML-V4 Version 0.7 defintions
#
# Fixed the p1 & p2 problems with multiple points representing a single point
# This does NOT work on CHRSET01 and CHRSET02 samples - out of the box.  They
# require additional work.
#
# CT2XML bears no warranty, either express or implied. Neither the US Navy nor NIST nor L. John Junod assumes legal
# liability nor responsibility for a User's use of CT2XML or the results of such use.
#
# THIS IS NOT PRODUCTION SOFTWARE!! USE WITH EXTREME CAUTION!! IT IS MERELY A PROTOTYPE TO SHOW THAT THE webCGM TS 
# CLEAR TEXT CGM SAMPLES CAN EASILY BE TRANSFORMED INTO CGM-XML per the CGMXML-V4 Version 0.7 DTD.  
#
# Fix any long names...
s?&?\&amp;?g
s?>?\&gt;?g
s?<?&lt;?g
s?ABSOLUTE?ABS?
s?ALIGNMENT?ALIGN?
s?ALTERNATE?ALT?
s?APPEND?APND?
s?APPLICATION?APPL?
s?APPLICATION STRUCTURE?APS?
s?ASPECT SOURCE FLAGS?ASFS?
s?ASPECT SOURCE FLAG?ASF?
s?ATTRIBUTES?ATTRS?
s?ATTRIBUTE?ATTR?
s?AUXILIARY?AUX?
s?BACKGROUND?BACK?
s?BEGIN?BEG?
s?CALIBRATION?CALIB?
s?CENTRE?CTR?
s?CHARACTER?CHAR?
s?CLIPPING?CLIP?
s?COLOUR?COLR?
s?COMPOUND?COMPO?
s?CONNECTING?CONN?
s?CONTEXT?CONT?
s?CONTINUATION?CONT?
s?CONTINUOUS?CONT?
s?CONTROL?CTRL?
s?COORDINATES?COORDS?
s?COORDINATE?COORD?
s?DEFINITION?DEF?
s?DESCRIPTION?DESC?
s?DEVICE?DEV?
s?DIRECTORY?DIR?
s?DISPLAY?DISP?
s?DISJOINT?DISJT?
s?EIGHT?8?
s?ELEMENT?ELEM?
s?ELLIPTICAL?ELLIP?
s?EXPANSION?EXPAN?
s?EXTENDED?EXTD?
s?EXTENT?EXT?
s?GENERALIZED?GEN?
s?GENERALIZED DRAWING PRIMITIVE?GDP?
s?GEOMETRIC?GEO?
s?HIGHLIGHTING?HIGHL?
s?HYPERBOLIC?HYPERB?
s?IDENTIFIER?ID?
s?INCREMENTAL?INCR?
s?INDIVIDUAL?INDIV?
s?INHERITANCE?INH?
s?INITIAL?INIT?
s?INTERIOR?INT?
s?INTERPOLATED?INTERP?
s?INVISIBLE?INVIS?
s?LIBRARY?LIB?
s?MAPPING?MAP?
s?MAXIMUM?MAX?
s?METAFILE?MF?
s?MILLIMETRE?MM?
s?NON-UNIFORM B-SPLINE?NUB?
s?NON-UNIFORM RATIONAL B-SPLINE?NURB?
s?NORMAL?NORM?
s?ORIENTATION?ORI?
s?PARABOLIC?PARAB?
s?PATTERN?PAT?
s?PHYSICAL?PHY?
s?PICTURE?PIC?
s?PLACEMENT?PLACEM?
s?PRESENTATION?PRES?
s?PRIMITIVE(S)?PRIM?
s?PRIORITY?PRI?
s?PROPERTIES?PROP?
s?PROTECTION?PROT?
s?POINT?PT?
s?POLYLINE?LINE?
s?POLYMARKER?MARKER?
s?POLYSYMBOL?SYMBOL?
s?PRECISION?PREC?
s?RECTANGLE?RECT?
s?REFERENCE?REF?
s?REPRESENTATION?REP?
s?RESTORE?RES?
s?RESTRICTED?RESTR?
s?REVERSED?REV?
s?SCALING?SCALE?
s?SEGMENT?SEG?
s?SEVEN?7?
s?SPACING?SPACE?
s?STATELIST?STLIST?
s?TRANSFORMATION?TRAN?
s?TRANSPARENT?TRANSP?
s?TWO?2?
s?VIEWPORT?VP?
s?VISIBILITY?VIS?
s?VISIBLE?VIS?
s?BEGIN METAFILE?BEGMF?
s?END METAFILE?ENDMF?
s?BEGIN PICTURE?BEGPIC?
s?BEGIN PICTURE BODY?BEGPICBODY?
s?END PICTURE?ENDPIC?
s?BEGIN SEGMENT?BEGSEG?
s?END SEGMENT?ENDSEG?
s?BEGIN FIGURE?BEGFIGURE?
s?END FIGURE?ENDFIGURE?
s?BEGIN PROTECTION REGION?BEGPROTREGION?
s?END PROTECTION REGION?ENDPROTREGION?
s?BEGIN COMPOUND LINE?BEGCOMPOLINE?
s?END COMPOUND LINE?ENDCOMPOLINE?
s?BEGIN COMPOUND TEXT PATH?BEGCOMPOTEXTPATH?
s?END COMPOUND TEXT PATH?ENDCOMPOTEXTPATH?
s?BEGIN TILE ARRAY?BEGTILEARRAY?
s?END TILE ARRAY?ENDTILEARRAY?
s?BEGIN APPLICATION STRUCTURE?BEGAPS?
s?BEGIN APPLICATION STRUCTURE BODY?BEGAPSBODY?
s?END APPLICATION STRUCTURE?ENDAPS?
s?METAFILE VERSION?MFVERSION?
s?METAFILE DESCRIPTION?MFDESC?
s?VDC TYPE?VDCTYPE?
s?INTEGER PRECISION?INTEGERPREC?
s?REAL PRECISION?REALPREC?
s?INDEX PRECISION?INDEXPREC?
s?COLOUR PRECISION?COLRPREC?
s?COLOUR INDEX PRECISION?COLRINDEXPREC?
s?MAXIMUM COLOUR INDEX?MAXCOLRINDEX?
s?COLOUR VALUE EXTENT?COLRVALUEEXT?
s?METAFILE ELEMENT LIST?MFELEMLIST?
s?METAFILE DEFAULTS REPLACEMENT?MFDEFAULTS?
s?FONT LIST?FONTLIST?
s?CHARACTER SET LIST?CHARSETLIST?
s?CHARACTER CODING ANNOUNCER?CHARCODING?
s?NAME PRECISION?NAMEPREC?
s?MAXIMUM VDC EXTENT?MAXVDCEXT?
s?SEGMENT PRIORITY EXTENT?SEGPRIEXT?
s?COLOUR MODEL?COLRMODEL?
s?COLOUR CALIBRATION?COLRCALIB?
s?FONT PROPERTIES?FONTPROP?
s?GLYPH MAPPING?GLYPHMAP?
s?SYMBOL LIBRARY LIST?SYMBOLLIBLIST?
s?PICTURE DIRECTORY?PICDIR?
s?SCALING MODE?SCALEMODE?
s?COLOUR SELECTION MODE?COLRMODE?
s?LINE WIDTH SPECIFICATION MODE?LINEWIDTHMODE?
s?MARKER SIZE SPECIFICATION MODE?MARKERSIZEMODE?
s?EDGE WIDTH SPECIFICATION MODE?EDGEWIDTHMODE?
s?VDC EXTENT?VDCEXT?
s?BACKGROUND COLOUR?BACKCOLR?
s?DEVICE VIEWPORT?DEVVP?
s?DEVICE VIEWPORT SPECIFICATION MODE?DEVVPMODE?
s?DEVICE VIEWPORT MAPPING?DEVVPMAP?
s?LINE REPRESENTATION?LINEREP?
s?MARKER REPRESENTATION?MARKERREP?
s?TEXT REPRESENTATION?TEXTREP?
s?FILL REPRESENTATION?FILLREP?
s?EDGE REPRESENTATION?EDGEREP?
s?INTERIOR STYLE SPECIFICATION MODE?INTSTYLEMODE?
s?LINE AND EDGE TYPE DEFINITION?LINEEDGETYPEDEF?
s?HATCH STYLE DEFINITION?HATCHSTYLEDEF?
s?GEOMETRIC PATTERN DEFINITION?GEOPATDEF?
s?APPLICATION STRUCTURE DIRECTORY?APSDIR?
s?VDC INTEGER PRECISION?VDCINTEGERPREC?
s?VDC REAL PRECISION?VDCREALPREC?
s?AUXILIARY COLOUR?AUXCOLR?
s?TRANSPARENCY?TRANSPARENCY?
s?CLIP RECTANGLE?CLIPRECT?
s?CLIP INDICATOR?CLIP?
s?LINE CLIPPING MODE?LINECLIPMODE?
s?MARKER CLIPPING MODE?MARKERCLIPMODE?
s?EDGE CLIPPING MODE?EDGECLIPMODE?
s?NEW REGION?NEWREGION?
s?SAVE PRIMITIVE CONTEXT?SAVEPRIMCONT?
s?RESTORE PRIMITIVE CONTEXT?RESPRIMCONT?
s?PROTECTION REGION INDICATOR?PROTREGION?
s?GENERALIZED TEXT PATH MODE?GENTEXTPATHMODE?
s?MITRE LIMIT?MITRELIMIT?
s?TRANSPARENT CELL COLOUR?TRANSPCELLCOLR?
s?POLYLINE?LINE?
s?DISJOINT POLYLINE?DISJTLINE?
s?POLYMARKER?MARKER?
s?TEXT?TEXT?
s?RESTRICTED TEXT?RESTRTEXT?
s?APPEND TEXT?APNDTEXT?
s?POLYGON?POLYGON?
s?POLYGON SET?POLYGONSET?
s?CELL ARRAY?CELLARRAY?
s?GENERALIZED DRAWING PRIMITIVE?GDP?
s?RECTANGLE?RECT?
s?CIRCLE?CIRCLE?
s?CIRCULAR ARC 3 POINT?ARC3PT?
s?CIRCULAR ARC 3 POINT CLOSE?ARC3PTCLOSE?
s?CIRCULAR ARC CENTRE?ARCCTR?
s?CIRCULAR ARC CENTRE CLOSE?ARCCTRCLOSE?
#s?ELLIPSE?ELLIPSE?
s?ELLIPTICAL ARC?ELLIPARC?
s?ELLIPTICAL ARC CLOSE?ELLIPARCCLOSE?
s?CIRCULAR ARC CENTRE REVERSED?ARCCTRREV?
s?CONNECTING EDGE?CONNEDGE?
s?HYPERBOLIC ARC?HYPERBARC?
s?PARABOLIC ARC?PARABARC?
s?NON-UNIFORM B-SPLINE?NUB?
s?NON-UNIFORM RATIONAL B-SPLINE?NURB?
s?POLYBEZIER?POLYBEZIER?
s?POLYSYMBOL?SYMBOL?
s?BITONAL TILE?BITONALTILE?
#s?TILE?TILE?
s?LINE BUNDLE INDEX?LINEINDEX?
s?LINE TYPE?LINETYPE?
s?LINE WIDTH?LINEWIDTH?
s?LINE COLOUR?LINECOLR?
s?MARKER BUNDLE INDEX?MARKERINDEX?
s?MARKER TYPE?MARKERTYPE?
s?MARKER SIZE?MARKERSIZE?
s?MARKER COLOUR?MARKERCOLR?
s?TEXT BUNDLE INDEX?TEXTINDEX?
s?TEXT FONT INDEX?TEXTFONTINDEX?
s?TEXT PRECISION?TEXTPREC?
s?CHARACTER EXPANSION FACTOR?CHAREXPAN?
s?CHARACTER SPACING?CHARSPACE?
s?TEXT COLOUR?TEXTCOLR?
s?CHARACTER HEIGHT?CHARHEIGHT?
s?CHARACTER ORIENTATION?CHARORI?
s?TEXT PATH?TEXTPATH?
s?TEXT ALIGNMENT?TEXTALIGN?
s?CHARACTER SET INDEX?CHARSETINDEX?
s?ALTERNATE CHARACTER SET INDEX?ALTCHARSETINDEX?
s?FILL BUNDLE INDEX?FILLINDEX?
s?INTERIOR STYLE?INTSTYLE?
s?FILL COLOUR?FILLCOLR?
s?HATCH INDEX?HATCHINDEX?
s?PATTERN INDEX?PATINDEX?
s?EDGE BUNDLE INDEX?EDGEINDEX?
s?EDGE TYPE?EDGETYPE?
s?EDGE WIDTH?EDGEWIDTH?
s?EDGE COLOUR?EDGECOLR?
s?EDGE VISIBILITY?EDGEVIS?
s?FILL REFERENCE POINT?FILLREFPT?
s?PATTERN TABLE?PATTABLE?
s?PATTERN SIZE?PATSIZE?
s?COLOUR TABLE?COLRTABLE?
s?ASPECT SOURCE FLAGS?ASF?
s?PICK IDENTIFIER?PICKID?
s?LINE CAP?LINECAP?
s?LINE JOIN?LINEJOIN?
s?LINE TYPE CONTINUATION?LINETYPECONT?
s?LINE TYPE INITIAL OFFSET?LINETYPEINITOFFSET?
s?TEXT SCORE TYPE?TEXTSCORETYPE?
s?RESTRICTED TEXT TYPE?RESTRTEXTTYPE?
s?INTERPOLATED INTERIOR?INTERPINT?
s?EDGE CAP?EDGECAP?
s?EDGE JOIN?EDGEJOIN?
s?EDGE TYPE CONTINUATION?EDGETYPECONT?
s?EDGE TYPE INITIAL OFFSET?EDGETYPEINITOFFSET?
s?SYMBOL LIBRARY INDEX?SYMBOLLIBINDEX?
s?SYMBOL COLOUR?SYMBOLCOLR?
s?SYMBOL SIZE?SYMBOLSIZE?
s?SYMBOL ORIENTATION?SYMBOLORI?
#s?ESCAPE?ESCAPE?
#s?MESSAGE?MESSAGE?
s?APPLICATION DATA?APPLDATA?
s?COPY SEGMENT?COPYSEG?
s?INHERITANCE FILTER?INHFILTER?
s?CLIP INHERITANCE?CLIPINH?
s?SEGMENT TRANSFORMATION?SEGTRAN?
s?SEGMENT HIGHLIGHTING?SEGHIGHL?
s?SEGMENT DISPLAY PRIORITY?SEGDISPPRI?
s?SEGMENT PICK PRIORITY?SEGPICKPRI?
s?APPLICATION STRUCTURE ATTRIBUTE?APSATTR?
#
# restore H8 to height
s/H8/HEIGHT/i
# end fixing long names
#
#
# delete leading spaces
s/^[ ]*//
#
# Form Initial Tags...
s?^ALTCHARSETINDEX?<&>?i
s?^APNDTEXT?<&>?i
s?^APPLDATA?<&>?i
s?^APSATTR?<&>?i
s?^APSDIR?<&>?i
s?^ARC3PTCLOSE?<&>?i
s?^ARC3PT?<&>?i
s?^ARCCTRCLOSE?<&>?i
s?^ARCCTR?<&>?i
s?^ARCCTRREV?<&>?i
s?^AUXCOLR?<&>?i
s?^BACKCOLR?<&>?i
s?^BEGAPSBODY?<BEGAPSBODY>?i
s?^BEGAPS?<BEGAPS>?i
s?^BEGCOMPOLINE?<BEGCOMPOLINE>?i
s?^BEGCOMPOTEXTPATH?<BEGCOMPOTEXTPATH>?i
s?^BEGFIGURE?<BEGFIGURE>?i
s?^BEGMFDEFAULTS?<BEGMFDEFAULTS>?i
s?^BEGMF?<BEGCGM>?i
s?^BEGPICBODY?<BEGPICBODY>?i
s?^BEGPIC?<BEGPIC>?i
s?^BEGPROTREGION?<BEGDEFPROTREGION>?i
s?^BEGSEG?<BEGSEG>?i
s?^BEGTILEARRAY?<BEGTILEARRAY>?i
s?^BITONALTILE?<&>?i
s?^CELLARRAY?<&>?i
s?^CHARCODING?<&>?i
s?^CHAREXPAN?<&>?i
s?^CHARHEIGHT?<&>?i
s?^CHARORI?<&>?i
s?^CHARSETINDEX?<&>?i
s?^CHARSETLIST?<&>?i
s?^CHARSPACE?<&>?i
s?^CIRCLE?<&>?i
s?^CLIPINH?<&>?i
s?^CLIPRECT?<&>?i
s?^CLIP?<&>?i
s?^COLRCALIB?<&>?i
s?^COLRINDEXPREC?<&>?i
s?^COLRMODEL?<&>?i
s?^COLRMODE?<&>?i
s?^COLRPREC?<&>?i
s?^COLRTABLE?<&>?i
s?^COLRVALUEEXT?<&>?i
s?^CONNEDGE?<&>?i
s?^COPYSEG?<&>?i
s?^DEVVPMAP?<&>?i
s?^DEVVPMODE?<&>?i
s?^DEVVP?<&>?i
s?^DISJTLINE?<&>?i
s?^EDGECAP?<&>?i
s?^EDGECLIPMODE?<&>?i
s?^EDGECOLR?<&>?i
s?^EDGEINDEX?<&>?i
s?^EDGEJOIN?<&>?i
s?^EDGEREP?<&>?i
s?^EDGETYPECONT?<&>?i
s?^EDGETYPEINITOFFSET?<&>?i
s?^EDGETYPE?<&>?i
s?^EDGEVIS?<&>?i
s?^EDGEWIDTHMODE?<&>?i
s?^EDGEWIDTH?<&>?i
s?^ELLIPARCCLOSE?<&>?i
s?^ELLIPARC?<&>?i
s?^ELLIPSE?<&>?i
s?^ENDAPS?<ENDAPS>?i
s?^ENDCOMPOLINE?<ENDCOMPOLINE>?i
s?^ENDCOMPOTEXTPATH?<ENDCOMPOTEXTPATH>?i
s?^ENDFIGURE?<ENDFIGURE>?i
s?^ENDMFDEFAULTS?<ENDMFDEFAULTS>?i
s?^ENDMF?</CGM>?i
s?^ENDPIC?<ENDPIC>?i
s?^ENDPROTREGION?<ENDDEFPROTREGION>?i
s?^ENDSEG?<ENDSEG>?i
s?^ENDTILEARRAY?<ENDTILEARRAY>?i
s?^ESCAPE?<&>?i
s?^FILLCOLR?<&>?i
s?^FILLINDEX?<&>?i
s?^FILLREFPT?<&>?i
s?^FILLREP?<&>?i
s?^FONTLIST?<&>?i
s?^FONTPROP?<&>?i
s?^GENTEXTPATHMODE?<&>?i
s?^GEOPATDEF?<&>?i
s?^GLYPHMAP?<&>?i
s?^HATCHINDEX?<&>?i
s?^HATCHSTYLEDEF?<&>?i
s?^HYPERBARC?<&>?i
s?^INCRDISJTLINE?<&>?i
s?^INCRLINE?<&>?i
s?^INCRMARKER?<&>?i
s?^INCRPOLYGONSET?<&>?i
s?^INCRPOLYGON?<&>?i
s?^INCRSYMBOL?<&>?i
s?^INDEXPREC?<&>?i
s?^INHFILTER?<&>?i
s?^INTEGERPREC?<&>?i
s?^INTERPINT?<&>?i
s?^INTSTYLEMODE?<&>?i
s?^INTSTYLE?<&>?i
s?^LINECAP?<&>?i
s?^LINECLIPMODE?<&>?i
s?^LINECOLR?<&>?i
s?^LINEEDGETYPEDEF?<&>?i
s?^LINEINDEX?<&>?i
s?^LINEJOIN?<&>?i
s?^LINEREP?<&>?i
s?^LINETYPECONT?<&>?i
s?^LINETYPEINITOFFSET?<&>?i
s?^LINETYPE?<&>?i
s?^LINEWIDTHMODE?<&>?i
s?^LINEWIDTH?<&>?i
s?^LINE?<&>?i
s?^MARKERCLIPMODE?<&>?i
s?^MARKERCOLR?<&>?i
s?^MARKERINDEX?<&>?i
s?^MARKERREP?<&>?i
s?^MARKERSIZEMODE?<&>?i
s?^MARKERSIZE?<&>?i
s?^MARKERTYPE?<&>?i
s?^MAXCOLRINDEX?<&>?i
s?^MAXVDCEXT?<&>?i
s?^MESSAGE?<&>?i
s?^MFDEFAULTS?<&>?i
s?^MFDESC?<&>?i
s?^MFELEMLIST?<&>?i
s?^MFVERSION?<&>?i
s?^MITRELIMIT?<&>?i
s?^NAMEPREC?<&>?i
s?^NEWREGION?<&>?i
s?^PARABARC?<&>?i
s?^PATINDEX?<&>?i
s?^PATSIZE?<&>?i
s?^PATTABLE?<&>?i
s?^PICDIR?<&>?i
s?^PICKID?<&>?i
s?^POLYBEZIER?<&>?i
s?^POLYGONSET?<&>?i
s?^POLYGON?<&>?i
s?^PROTREGION?<&>?i
s?^REALPREC?<&>?i
s?^RESPRIMCONT?<&>?i
s?^RESTRTEXTTYPE?<&>?i
s?^RESTRTEXT?<&>?i
s?^SAVEPRIMCONT?<&>?i
s?^SCALEMODE?<&>?i
s?^SEGDISPPRI?<&>?i
s?^SEGHIGHL?<&>?i
s?^SEGPICKPRI?<&>?i
s?^SEGPRIEXT?<&>?i
s?^SEGTRAN?<&>?i
s?^SYMBOLCOLR?<&>?i
s?^SYMBOLLIBINDEX?<&>?i
s?^SYMBOLLIBLIST?<&>?i
s?^SYMBOLORI?<&>?i
s?^SYMBOLSIZE?<&>?i
s?^TEXTALIGN?<&>?i
s?^TEXTCOLR?<&>?i
s?^TEXTFONTINDEX?<&>?i
s?^TEXTINDEX?<&>?i
s?^TEXTPATH?<&>?i
s?^TEXTPREC?<&>?i
s?^TEXTREP?<&>?i
s?^TEXTSCORETYPE?<&>?i
s?^TEXT?<&>?i
s?^TILE?<&>?i
s?^TRANSPARENCY?<&>?i
s?^TRANSPCELLCOLR?<&>?i
s?^VDCEXT?<&>?i
s?^VDCINTEGERPREC?<&>?i
s?^VDCREALPREC?<&>?i
s?^VDCTYPE?<&>?i
#
#remove ; from >;
s?>;?>?
#add endtags where possible
s?^<\(.*\)>\(.*\);?<\1>\2</\1>?
s?;\
?</>?
#find and mark stings
s?""?\&DOUBLEQUOTE!?
s?""?\&DOUBLEQUOTE!?
s?""?\&DOUBLEQUOTE!?
s?""?\&DOUBLEQUOTE!?
s?""?\&DOUBLEQUOTE!?
s?""?\&DOUBLEQUOTE!?
s?""?\&DOUBLEQUOTE!?
s?""?\&DOUBLEQUOTE!?
s?""?\&DOUBLEQUOTE!?
s?''?\&SINGLEQUOTE!?
s?''?\&SINGLEQUOTE!?
s?''?\&SINGLEQUOTE!?
s?''?\&SINGLEQUOTE!?
s?''?\&SINGLEQUOTE!?
s?''?\&SINGLEQUOTE!?
s?''?\&SINGLEQUOTE!?
s?''?\&SINGLEQUOTE!?
s?''?\&SINGLEQUOTE!?
s?[ >,]"?<S>?g
s?"[ ,;/]?</S>?g
s?"[<;]?</S><?gg
s?[ >,]'?<S>?g
s?'[ ,;/]?</S>?g
s?'<?</S><?gg
# Save spaces within strings
s? ?~+?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
s?<S>\(.*\)~+\(.*\)</S>?<S>\1 \2</S>?g
#change / to ; outside of strings
s?~+/?;?g
# delete initial spaces outside of strings
s?>~+?>?g
#delete trailing spaces outside of strings
s?~+<?<?g
# Fix beginning marker
s?<BEG\(.*\)>?<\1>?gi
# remove extraneous BEGxxxx markers at ends of lines
s?</BEG.*??
#Fix end markers to </
s?<END\(.*\)>?</\1>?gi
# Fix Empty Tags...
s?>\(ABS\)<?><\1/><?gg
s?>\(ABSTRACT\)<?><\1/><?gg
s?>\(ACTION\)<?><\1/><?g
s?>\(AFSTYPE\)<?><\1/><?g
s?>\(ALL\)<?><\1/><?g
s?>\(ALLATTRCTRL\)<?><\1/><?g
s?>\(ALLEDGE\)<?><\1/><?g
s?>\(ALLFILL\)<?><\1/><?g
s?>\(ALLINH\)<?><\1/><?g
s?>\(ALLLINE\)<?><\1/><?g
s?>\(ALLMARKER\)<?><\1/><?g
s?>\(ALLTEXT\)<?><\1/><?g
s?>\(AXIS\)<?><\1/><?g
s?>\(BASIC7BIT\)<?><\1/><?g
s?>\(BASIC8BIT\)<?><\1/><?g
s?>\(BEGAPSBODY\)<?><\1/><?g
s?>\(BEGCOMPOLINE\)<?><\1/><?g
s?>\(BEGCOMPOTEXTPATH\)<?><\1/><?g
s?>\(BEGFIGURE\)<?><\1/><?g
s?>\(BEGPICBODY\)<?><\1/><?g
s?>\(BOTH\)<?><\1/><?g
s?>\(BOTTOM\)<?><\1/><?g
s?>\(BUNDLED\)<?><\1/><?g
s?>\(CAP\)<?><\1/><?g
s?>\(CHAR\)<?><\1/><?g
s?>\(CHAREXPANASF\)<?><\1/><?g
s?>\(CHARSPACEASF\)<?><\1/><?g
s?>\(CHORD\)<?><\1/><?g
s?>\(CLOSEINVIS\)<?><\1/><?g
s?>\(CLOSEVIS\)>?><\1/><?g
s?>\(COMPLETECODE\)<?></CHARSETDESIGNATOR><CHARSETDESIGNATOR><\1/><?g
s?>\(CONNEDGE\)<?><\1/><?g
s?>\(CONTHORIZ\)<?><\1/><?g
s?>\(CONTVERT\)<?><\1/><?g
s?>\(CROSSHATCH\)<?><\1/><?g
s?>\(CTR\)<?><\1/><?g
s?>\(CTR~+\)?><CTR/>?g
s?>\(DEFAPS\)<?><\1/><?g
s?>\(DIRECT\)<?><\1/><?g
s?>\(DOWN\)<?><\1/><?g
s?>\(EDGEATTR\)<?><\1/><?g
s?>\(EDGECOLRASF\)<?><\1/><?g
s?>\(EDGETYPEASF\)<?><\1/><?g
s?>\(EDGEWIDTHASF\)<?><\1/><?g
s?>\(EMPTY\)<?><\1/><?g
s?>\(EXTD7BIT\)<?><\1/><?g
s?>\(EXTD8BIT\)<?><\1/><?g
s?>\(FILLATTR\)<?><\1/><?g
s?>\(FILLCOLRASF\)<?><\1/><?g
s?>\(FORCED\)<?><\1/><?g
s?>\(FRACTION\)<?><\1/><?g
s?>\(FRACTIONAL\)<?><\1/><?g
s?>\(GEOPAT\)<?><\1/><?g
s?>\(HALF\)<?><\1/><?g
s?>\(HATCH\)<?><\1/><?g
s?>\(HATCHINDEXASF\)<?><\1/><?g
s?>\(HEIGHT\)<?><\1/><?g
s?>\(HIGHL\)<?><\1/><?g
s?>\(HOLLOW\)<?><\1/><?g
s?>\(INDEXED\)<?><\1/><?g
s?>\(INDIV\)<?><\1/><?g
s?>\(INTEGER\)<?><\1/><?g
s?>\(INTERP\)<?><\1/><?g
s?>\(INTERPOLATEDINTERIOR\)<?><\1/><?g
s?>\(INTERSECTION\)<?><\1/><?g
s?>\(INTSTYLEASF\)<?><\1/><?g
s?>\(INVIS\)<?><\1/><?g
s?>\(LEFT\)<?><\1/><?g
s?>\(LEFT~+\)?><\LEFT/>?g
s?>\(LINEATTR\)<?><\1/><?g
s?>\(LINECOLRASF\)<?><\1/><?g
s?>\(LINETYPEASF\)<?><\1/><?g
s?>\(LINEWIDTHASF\)<?><\1/><?g
s?>\(LOCUS\)<?><\1/><?g
s?>\(LOCUSTHENSHAPE\)<?><\1/><?g
s?>\(MARKERATTR\)<?><\1/><?g
s?>\(MARKERCOLRASF\)<?><\1/><?g
s?>\(MARKERSIZEASF\)<?><\1/><?g
s?>\(MARKERTYPEASF\)<?><\1/><?g
s?>METRIC?><METRIC/>?g
s?>\(MM\)<?><\1/><?g
s?>\(NEWREGION\)<?><\1/><?g
s?>\(NO\)<?><\1/><?g
s?>\(NOACTION\)<?><\1/><?g
s?>\(NONAXIS\)<?><\1/><?g
s?>\(NORMAL\)<?><\1/><?g
s?>\(NORMHORIZ\)<?><\1/><?g
s?>\(NORMVERT\)<?><\1/><?g
s?>\(NOTFORCED\)<?><\1/><?g
s?>\(OFF\)<?><\1/><?g
s?>\(ON\)<?><\1/><?g
s?>\(OUTPUTCTRL\)<?><\1/><?g
s?>\(PARALLEL\)<?><\1/><?g
s?>\(PAT\)<?><\1/><?g
s?>\(PATATTR\)<?><\1/><?g
s?>\(PATINDEXASF\)<?><\1/><?g
s?>\(PHYDEVCOORD\)<?><\1/><?g
s?>\(PIE\)<?><\1/><?g
s?>\(REAL\)<?><\1/><?g
s?>\(RIGHT\)<?><\1/><?g
s?>\(RIGHT~+\)?><RIGHT/>?g
s?>\(SCALED\)<?><\1/><?g
s?>\(SEG\)<?><\1/><?g
s?>\(SHAPE\)<?><\1/><?g
s?>\(SOLID\)<?><\1/><?g
s?>\(STD94\)<?></CHARSETDESIGNATOR><CHARSETDESIGNATOR><\1/><?g
s?>\(STD94MULTIBYTE\)<?></CHARSETDESIGNATOR><CHARSETDESIGNATOR><\1/><?g
s?>\(STD96\)<?></CHARSETDESIGNATOR><CHARSETDESIGNATOR><\1/><?g
s?>\(STD96MULTIBYTE\)<?></CHARSETDESIGNATOR><CHARSETDESIGNATOR><\1/><?g
s?>STLIST?><STLIST/>?g
s?>\(STRING\)<?><\1/><?g
s?>\(STROKE\)<?><\1/><?g
s?>\(SYMBOLATTR\)<?><\1/><?g
s?>\(SYMBOLLIBINDEX\)<?><\1/><?g
s?>\(TEXPRESANDPLACEMATTR\)<?><\1/><?g
s?>\(TEXTCOLRASF\)<?><\1/><?g
s?>\(TEXTFONTINDEXASF\)<?><\1/><?g
s?>\(TEXTPLACEMANDORIATTR\)<?><\1/><?g
s?>\(TEXTPRECASF\)<?><\1/><?g
s?>\(TOP\)<?><\1/><?g
s?>\(UI16\)<?><\1/><?g
s?>\(UI32\)<?><\1/><?g
s?>\(UI8\)<?><\1/><?g
s?>\(UP\)<?><\1/><?g
s?>\(VIS\)<?><\1/><?g
s?>\(WIDTH\)<?><\1/><?g
s?>\(YES\)<?><\1/><?g
s?>BASE?><BASE/>?g
s?~+BASE<?<BASE/><?g
# change the ~+ back to space
s?~+? ?g
# fix singlequote and doublequote entities
s? &DOUBLEQUOTE!["']? <S>\&DOUBLEQUOTE!?g
s?&DOUBLEQUOTE!["']?\&DOUBLEQUOTE!</S>?g
s?&DOUBLEQUOTE!?\&quot;?g
s? &SINGLEQUOTE!["']? <S>\&SINGLEQUOTE!?g
s?&SINGLEQUOTE!["']?\&SINGLEQUOTE!</S>?g
s?&SINGLEQUOTE!?\&apos;?g
# Fix extra " and '
s?>"?><S>?g
s?"<?</S><?g
s?>'?><S>?g
s?'<?</S><?g
# Fix missing tags
# missing APSBODY
s?^</APS>?</APSBODY>\
&?
# missing PICBODY
s?^</PIC>?</PICBODY>\
&?
# Put in missing XML
s+^<CGM>+<?xml version ="1.0" ?>\
\
<!--\
This is Sample XML Markup Based on cgmxml-v4.dtd Version 0.7 2003-05-16.\
\
The XML tags and information is SUBJECT TO CHANGE WITHOUT NOTICE as the CGM community\
discusses a more formal CGM-XML approach and is provided WITHOUT ANY WARRANTY; without even the implied warranty of\
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  Please consult the http://www.cgmopen.org web site for\
more information.\
\
This Sample is a part of the webCGM Test Suite Copyright (C) 2002, Lofton Henderson. All Rights Reserved.\
Please see accompanying license agreement 'copyright-license.html' for the full details.\
-->\
<!DOCTYPE CGM SYSTEM "..\\dtd\\cgmxml-v4.dtd">\
<?xml-stylesheet type="text/xsl" href="..\\xsl\\cgmxml2ct.xslt"?>\
&+
# suppress unused spaces not in strings
s?\([ABCDEFGHIJKLMNOPQRTUVWXYZ]>\) ?\1?g
s? \([ABCDEFGHIJKLMNOPQRTUVWXYZ]<\)?\1?g
# remove carriage returns
s?\
??
# Fix children of <CHARSETLIST> 
s?</CHARSETLIST>?</CHARSETDESIGNATOR>&?
s?<CHARSETLIST></CHARSETDESIGNATOR>?<CHARSETLIST>?
# Fix APSATTR
s?<APSATTR><S>layername</S><S>\([0-9 ]*\)<S>\(.*\)</S></APSATTR>?<APSATTR type="layername" apsnum="\1" data="\2"/>?
s?<APSATTR><S>layerdesc</S><S>\([0-9 ]*\)<S>\(.*\)</S></APSATTR>?<APSATTR type="layerdesc" apsnum="\1" data="\2"/>?
s?<APSATTR><S>region</S><S>\([0-9 ]*\)<S>\(.*\)</S></APSATTR>?<APSATTR type="region" apsnum="\1" data="\2"/>?
##<APSATTR><S>region</S><S>11 1 1, 16 4 48.0099 39.34 94.01 25.3399</S></APSATTR>
s?<APSATTR><S>region</S><S>\([0-9 ]*\)\(.*\)\([1234],.*\)</S></APSATTR>?<APSATTR type="region" apsnum="\1 \2" data="\3"/>?
s?<APSATTR><S>region</S><S>\([0-9 ]*\)\(.*\)\([1234],.*\)?<APSATTR type="region" apsnum="\1 \2" data="\3?
s?<APSATTR><S>viewcontext</S><S>\([0-9 ]*\)<S>\(.*\)</S></APSATTR>?<APSATTR type="viewcontext" apsnum="\1" data="\2"/>?
s?<APSATTR><S>viewcontext</S><S>\([0-9]* [0-9]* \)\(.*\)</S></APSATTR>?<APSATTR type="viewcontext" apsnum="\1" data="\2"/>?
s?<APSATTR><S>linkuri</S><S>\([0-9 ]*\)<S>\(.*\)</S></APSATTR>?<APSATTR type="linkuri" apsnum="\1" data="\2"/>?
s?</S>&apos;<S>?\&apos;?
s?</S>&apos; &apos;?\&apos; \&apos;?
s?<APSATTR><S>screentip</S><S>\([0-9 ]*\)<S>\(.*\)</S></APSATTR>?<APSATTR type="screentip" apsnum="\1" data="\2"/>?
s?<APSATTR><S>content</S><S>\([0-9 ]*\)<S>\(.*\)</S></APSATTR>?<APSATTR type="content" apsnum="\1" data="\2"/>?
s?<APSATTR><S>name</S><S>\([0-9 ]*\)<S>\(.*\)</S></APSATTR>?<APSATTR type="name" apsnum="\1" data="\2"/>?
# catch all in case we missed something..
#s?\(<APSATTR><S>.*</S>\)<S>\(.*\)</S>?\1<SDR><S>\2</S></SDR>?
#Fix FINAL keyword
s? \(FINAL\)[ ]*<? <FINAL/><?ig
#FIX NOTFINAL Keyword
s? \(NOTFINAL\)[ ]*<? <NOTFINAL/><?ig
# Fix <S></RESTRTEXT>
s?<S></RESTRTEXT>?</S></RESTRTEXT>?
# Fix webCGM Constructs in APS
s?\(<APS><S>.*</S>\)<S>grobject</S>?\1<grobject/>?
s?\(<APS><S>.*</S>\)<S>layer</S>?\1<layer/>?
s?\(<APS><S>.*</S>\)<S>para</S>?\1<para/>?
s?\(<APS><S>.*</S>\)<S>subpara</S>?\1<subpara/>?
# Fix missing end of POLYBEZIER or POINTLIST or POLYGON
s?^;?"/>?
s?\([0-9]\);?\1"/>?
# Fix TILE or BITONALTILE WIDOW LINES
s?^\([0-9ABCDEF]*\);?\1"/>?i
# Fix BITONALTILE
s?^\(<BITONALTILE>.*\)&apos;?\1<S></S>?
#
s?<TM>\(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\)</TM>?<TM a11="\1" a12="\2" a21="\3" a22="\4" a13="\5" a23="\6"/>?
#
s?<SEG>\(.*\)</SEG>?<SEG segid="\1"/>?
#
s?<TILEARRAY>\(.*,.*\) \([091827]*\) \([9027]*\) \([0-9]*\) \([0-9]\) \([0-9]*\) \([0-9]*\)?\
<TILEARRAY position="\1" angle1 = "\2" angle2 = "\3" tilesperpath="\4" tilesperline="\5" cellspertilepath="\6" cellspertileline="\7" ?
s?\(<TILEARRAY.*cellspertileline=".*" \)\(.*\) \(.*\) \([0-9]*\) \([0-9]\) \([0-9]*\) \([0-9]*\)?\1cellspacing="\2" linespacing="\3" pathoffset="\4" lineoffset="\5" cellsperpath="\6" cellsperline="\7">?
#
s?<APS><S>\(.*\)</S><\(.*\)/><\(.*\)/>?<APS apsid="\1" apstype="\2" set="\3">?
#
s?<MFVERSION>\(.*\)</MFVERSION>?<MFVERSION version="\1"/>?
#
s?<VDCTYPE><\(.*\)/></VDCTYPE>?<VDCTYPE type="\1"/>?
#
s?<INTEGERPREC>\(.*\) \(.*\)</INTEGERPREC>?<INTEGERPREC min="\1" max="\2"/>?
#
s?<REALPREC>\(.*\) \(.*\) \(.*\)</REALPREC>?<REALPREC min="\1" max="\2" digits="\3"/>?
#
s?<COLRPREC>\(.*\)</COLRPREC>?<COLRPREC max="\1"/>?
#
s?<COLRINDEXPREC>\(.*\)</COLRINDEXPREC>?<COLRINDEXPREC max="\1"/>?
#
s?<MAXCOLRINDEX>\(.*\)</MAXCOLRINDEX>?<MAXCOLRINDEX max="\1"/>?
#
s?<COLRVALUEEXT>\([0-9]*\) \([0-9]*\) \([0-9]*\) \([0-9]*\) \([0-9]*\) \([0-9]*\)</COLRVALUEEXT>?<COLRVALUEEXT white="\1 \2 \3" black="\4 \5 \6"/>?
#        white CDATA #IMPLIED
#        black CDATA #IMPLIED
#        scale1 CDATA #IMPLIED
#        offset1 CDATA #IMPLIED
#        scale2 CDATA #IMPLIED
#        offset2 CDATA #IMPLIED
#        scale3 CDATA #IMPLIED
#        offset3 CDATA #IMPLIED
#
s?<CHARSETDESIGNATOR><\([A-Z0-9]*\)/><S>\([A-Z]\)</S></CHARSETDESIGNATOR>?<DESIGNATOR charset="\1" tail="\2"/>?g
#
s?<CHARCODING><\(.*\)/></CHARCODING>?<CHARCODING coding="\1"/>?
#
s?<NAMEPREC>\(.*\) \(.*\)</NAMEPREC>?<NAMEPREC min="\1" max="\2"/>?
#
s?<MAXVDCEXT>\(.*\) \(.*\)</MAXVDCEXT>?<MAXVDCEXT p1="\1" p2="\2"/>?
#
s?<SEGPRIEXT>\(.*\) \(.*\)</SEGPRIEXT>?<SEGPRIEXT min="\1" max="\2"/>?
#
#s?<RGBCALIBDATA>\(.*\)
#        xr="\1"?
#        xg="\2"?
#        xb="\3"?
#        yr="\4"?
#        yg="\5"?
#        yb="\6"?
#        zr="\7"?
#        zg="\8"?
#        zb="\9"?
#        ra="\x"?
#        rb="\x"?
#        rc="\x"?
#        ga="\x"?
#        gb="\x"?
#        gc="\x"?
#        ba="\x"?
#        bb="\x"?
#        bc="\x"?
#        lutlength="\x"?
#
#s?<RLUTENTRY>\(.*\)
#        r="\1"?
#        rprime="\2"?
#?
#s?<GLUTENTRY>\(.*\)
#        g="\1"?
#        gprime="\2"?
#?
#s?<BLUTENTRY>\(.*\)
#        b="\1"?
#        bprime="\2"?
#?
#s?<CMYKCALIBDATA>\(.*\)
#        length="\1"?
#        directk="\2"?
#        xyzgridlocations="\3"?
#?
s?<XYZGRIDLOCATION>\(.*\) \(.*\) \(.*\)</XYZGRIDLOCATION>?<XYZGRIDLOCATION XYZX="\1" XYZY="\2" XYZZ="\3"/>?
#
s?<PROPERTY3TUPLE>\(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\)</PROPERTY3TUPLE>?<PROPERTY3TUPLE priorityindicator="\1" priority="\2" sdr="\3" fontindex="\4" standardversion="\5" posture="\6" weight="\7" proportionatewidth="\8"/>?
#
s?<INCLUDGLYPHCOLLECT>\(.*\)?</INCLUDGLYPHCOLLECT><INCLUDGLYPHCOLLECT charsetindex="\1"/>?
#
s?<INCLUDGLYPH>\(.*\) \(.*\) \(.*\) \(.*\) \(.*\)</INCLUDGLYPH>?<INCLUDGLYPH afii="\1" designsize="\2" minsize="\3" maxsize="\4" structure="\5"/>?
#
#s?<GLYPHMAP (#PCDATA)?
#s?<GLYPHMAP>\(.*\)
#        charset="\x"?
#        charset (STD94 | STD96 | STD94MULTIBYTE | STD96MULTIBYTE | COMPLETECODE) #REQUIRED
#        tail="\x"?
#        octets="\x"?
#        source="\x"?
#
s?<SYMBOLLIBLIST>\(.*\)</SYMBOLLIBLIST?<SYMBOLLIBLIST symbolnames="\1"/>?
#
s?<PICDIR><\(.*\)/>\(.*\) \(.*\) \(.*\)</PICDIR>?<PICDIR set="\1" picid="\2" picloc="\3" apsdirloc="\4"/>?
#
s?<PICDIRTRIPLE>\(.*\) \(.*\) \(.*\)</PICDIRTRIPLE>?<PICDIRTRIPLE picid="\1" picloc="\2" apsdirloc="\3"/>?
#
s?<SCALEMODE><\(.*\)/>\(.*\)</SCALEMODE>?<SCALEMODE type="\1" scalefactor="\2"/>?
#
s?<COLRMODE><\(.*\)/></COLRMODE>?<COLRMODE set="\1"/>?
#
s?<LINEWIDTHMODE><\(.*\)/></LINEWIDTHMODE>?<LINEWIDTHMODE set="\1"/>?
#
s?<MARKERSIZEMODE><\(.*\)/></MARKERSIZEMODE>?<MARKERSIZEMODE set="\1"/>?
#
s?<EDGEWIDTHMODE><\(.*\)/></EDGEWIDTHMODE>?<EDGEWIDTHMODE set="\1"/>?
#
s?<VDCEXT>\(.*\) \(.*\)</VDCEXT>?<VDCEXT p1="\1" p2="\2"/>?
#
s?<LINEREP>\(.*\) \(.*\) \(.*\) \(.*\)</LINEREP>?<LINEREP bundle="\1" type="\2" width="\3" color="\4"/>?
#
s?<MARKERREP>\(.*\) \(.*\) \(.*\) \(.*\)</MARKERREP>?<MARKERREP bundle="\1" type="\2" width="\3" color="\4"/>?
#
s?<TEXTREP>\(.*\)<\(.*\)/>\(.*\) \(.*\) \(.*\)</TEXTREP>?<TEXTREP font="\1" set="\2" spacing="\3" factor="\4" color="\5"/>?
#
s?<FILLREP>\(.*\)<\(.*\)/>\(.*\) \(.*\) \(.*\)</FILLREP>?<FILLREP bundle="\1" set="\2" fillk="\3" hatch="\4" pat="\5"/>?
#
s?<INTSTYLEMODE><\(.*\)/></INTSTYLEMODE>?<INTSTYLEMODE set="\1"/>?
#
s?<LINEEDGETYPEDEF>\(.*\) \(.*\) \(.*\)</LINEEDGETYPEDEF>?<LINEEDGETYPEDEF type="\1" repeatlenght="\2" dashelements="\3"/>?
#
s?<HATCHSTYLEDEF>\(.*\)<\(.*\)/ \(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\)</HATCHSTYLEDEF>?\
<HATCHSTYLEDEF index="\1" set="\2" v1x="\3" v1y="\4" v2x="\5" v2y="\6" dutycycle="\7" numlines="\8" gap="\9" linetype="\0"/>?
#
s?<GEOPATDEF>\(.*\) \(.*\) \(.*\) \(.*\)</GEOPATDEF>?<GEOPATDEF geopatindex="\1" segid="\2" p1="\3" p2="\4"/>?
#
s?<APSDIRPAIR>\(.*\) \(.*\)</APSDIRPAIR>?<APSDIRPAIR apsnum="\1" location="\2"/>?
#
s?<VDCINTEGERPREC>\(.*\) \(.*\)</VDCINTEGERPREC>?<VDCINTEGERPREC min="\1" max="\2"/>?
#
s?<VDCREALPREC>\(.*\) \(.*\) \(.*\)</VDCREALPREC>?<VDCREALPREC min="\1" max="\2" digits="\3"/>?
#
s?<AUXCOLR>\(.*\)</AUXCOLR>?<AUXCOLR k="\1"/>?
#
s?<TRANSPARENCY><\(.*\)/></TRANSPARENCY>?<TRANSPARENCY set="\1"/>?
#
s?<CLIP><\(.*\)/></CLIP>?<CLIP set="\1"/>?
#
s?<LINECLIPMODE><\(.*\)/></LINECLIPMODE>?<LINECLIPMODE set="\1"/>?
#
s?<MARKERCLIPMODE><\(.*\)/></MARKERCLIPMODE>?<MARKERCLIPMODE set="\1"/>?
#
s?<EDGECLIPMODE><\(.*\)/></EDGECLIPMODE>?<EDGECLIPMODE set="\1"/>?
#
s?<SAVEPRIMCONT>\(.*\)</SAVEPRIMCONT>?<SAVEPRIMCONT contextname="\1"/>?
#
s?<RESPRIMCONT>\(.*\)</RESPRIMCONT>?<RESPRIMCONT contextname="\1"/>?
#
s?<PROTREGION>\(.*\) \(.*\)</PROTREGION>?<PROTREGION regionindex="\1" regionindicator="\2"/>?
#
s?<GENTEXTPATHMODE><\(.*\)/></GENTEXTPATHMODE>?<GENTEXTPATHMODE set="\1"/>?
#
s?<MITRELIMIT>\(.*\)</MITRELIMIT>?<MITRELIMIT mitrelimit="\1"/>?
#
s?<TRANSPCELLCOLR><\(.*\)/>\(.*\)</TRANSPCELLCOLR>?<TRANSPCELLCOLR set="\1" k="\2"/>?
#
s?<LINE>\(.*\)</LINE>?<LINE pointlist="\1"/>?
s?<LINE>\(.*\)?<LINE pointlist="\1?
#
s?<INCRLINE>\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\)</INCRLINE>?<INCRLINE p1="\1\2\3,\4\5\6" deltas="\7"/>?
s?<INCRLINE>\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\)?<INCRLINE p1="\1\2\3,\4\5\6" deltas="\7?
#
s?<INCRDISJTLINE>\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\)</INCRDISJTLINE>?<INCRDISJTLINE p1="\1\2\3,\4\5\6" deltas="\7"/>?
s?<INCRDISJTLINE>\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\)?<INCRDISJTLINE p1="\1\2\3,\4\5\6" deltas="\7?
#
s?<MARKER>\(.*\)</MARKER>?<MARKER points="\1"/>?
#
s?<INCRMARKER>\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\)</INCRMARKER>?<INCRMARKER p1="\1\2\3,\4\5\6" deltas="\7"/>?
#
s?<TEXT>\(.*\)<\(.*\)/>\(.*\)</TEXT>?<TEXT textlocation="\1" textpiece="\2">\3</TEXT>?
#
s?<RESTRTEXT>\(.*\) \(.*\) \(.*,.*\)<\(.*\)/>\(<S>.*</S>\)</RESTRTEXT>?<RESTRTEXT maxwidth="\1" maxheight="\2" textlocation="\3" textpiece="\4">\5</RESTRTEXT>?
#
#s?<APNDTEXT><\(.*\)/> \(.*\)</APNDTEXT>?<APNDTEXT textpiece="\1">\2</APNDTEXT>?
s?<APNDTEXT>notfinal<\(.*\)></APNDTEXT>?<APNDTEXT textpiece="NOTFINAL"><\1></APNDTEXT>?i
s?<APNDTEXT>final<\(.*\)></APNDTEXT>?<APNDTEXT textpiece="FINAL"><\1></APNDTEXT>?i
#
s?<POLYGON>\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\) \(.*\)</POLYGON>?<POLYGON p1="\1\2\3,\4\5\6" p2="\7 \8"/>?
s?<POLYGON>\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\) \(.*\)?<POLYGON p1="\1\2\3,\4\5\6" p2="\7 \8?
s?<POLYGON p1=\(.*\)p2="\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\)?<POLYGON p1=\1p2="\2\3\4,\5\6\7" points="\8?
#
s?<INCRPOLYGON>\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\)</INCRPOLYGON>?<INCRPOLYGON p1="\1\2\3,\4\5\6" deltas="\7"/>?
#
s?<FLAGGEDPOINT>\(.*\) \(.*\)</FLAGGEDPOINT>?<FLAGGEDPOINT vertex="\1" edgeflag="\2"/>?
#
s?<FLAGGEDDELTA>\(.*\) \(.*\)</FLAGGEDDELTA>?<FLAGGEDDELTA delta="\1" edgeflag="\2"/>?
#
#s?<LOCLCOLRPREC>\(.*\) \(.*\)</LOCLCOLRPREC>?<LOCLCOLRPREC maxint CDATA #IMPLIED
#        maxcomponent CDATA #IMPLIED
#
s?<GDP>\(.*\) \(.*\) \(.*\)</GDP>?<GDP ident="\1" pointlist="\2" data="\3"/>?
#
s?<RECT>\(.*\) \(.*\)</RECT>?<RECT p1="\1" p2="\2"/>?
#
s?<CIRCLE>\(.*\) \(.*\)</CIRCLE>?<CIRCLE p1="\1" radius="\2"/>?
#
s?<ARC3PT>\(.*\) \(.*\) \(.*\)</ARC3PT>?<ARC3PT p1="\1" p2="\2" p3="\3"/>?
#
s?<ARCCTR>\(.*\) \(.*\) \(.*\) \(.*\)</ARCCTR>?<ARCCTR center="\1" start="\2" end="\3" radius="\4"/>?
#
s?<ELLIPSE>\(.*\) \(.*\) \(.*\)</ELLIPSE>?<ELLIPSE center="\1" endp1="\2" endp2="\3"/>?
#
s?<ELLIPARC>\(.*,.*\) \(.*,.*\) \(.*,.*\) \(.* .*\) \(.* .*\)</ELLIPARC>?<ELLIPARC center="\1" endp1="\2" endp2="\3" start="\4" end="\5"/>?
#
s?<ELLIPARCCLOSE>\(.*,.*\) \(.*,.*\) \(.*,.*\) \(.* .*\) \(.* .*\)<\(.*\)/></ELLIPARCCLOSE>?\
<ELLIPARCCLOSE center="\1" endp1="\2" endp2="\3" start="\4" end="\5" closespec="\6"/>?
#
s?<HYPERBARC>\(.*,.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\)</HYPERBARC>?\
<HYPERBARC center="\1" transversep="\2" conjugatep="\3" startx="\4" starty="\5" endx="\6" endy="\7"/>?
#
s?<PARABARC>\(.*\) \(.*\) \(.*\)</PARABARC>?<PARABARC p1="\1" p2="\2" p3="\3"/>?
#
s?<NUB>\(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\)</NUB>?<NUB splineorder="\1" numpoints="\2" controlpoint="\3" knot="\4" start="\5" end="\6"/>?
#
s?<NURB>\(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\) \(.*\)</NURB>?<NURB splineorder="\1" numpoints="\2" controlpoint="\3" knot="\4" start="\5" end="\6" weight="\7"/>?
#
s?<POLYBEZIER>\([0-9]*\) \(.*\)</POLYBEZIER>?<POLYBEZIER continuity="\1" points="\2"/>?
s?<POLYBEZIER>\([0-9]*\) \(.*\)?<POLYBEZIER continuity="\1" points="\2?
#
s?<SYMBOL>\(.*\) \([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\)</SYMBOL>?<SYMBOL index="\1" p1="\2\3\4,\5\6\7" points="\8"/>?
#
s?<INCRSYMBOL>\(.*\) \([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\),\([-]*[0-9][0-9-]*\)\([.eE]*\)\([-]*[0-9]*[0-9-]*\) \(.*\)</INCRSYMBOL>?<INCRSYMBOL index="\1" p1="\2\3\4,\5\6\7" deltas="\8"?
#
s?<BITONALTILE>\([0-9]*\) \([0-9]*\) \([0-9]* [0-9]* [0-9]*\) \([0-9]* [0-9]* [0-9]*\)[ ]*<S>\(.*\)</S>\(.*\)</BITONALTILE>?<BITONALTILE type="\1" rowpad="\2" background="\3" foreground="\4" params="\5" data="\6"/>?
s?<BITONALTILE>\([0-9]*\) \([0-9]*\) \([0-9]* [0-9]* [0-9]*\) \([0-9]* [0-9]* [0-9]*\)[ ]*<S>\(.*\)</S>\(.*\)?<BITONALTILE type="\1" rowpad="\2" background="\3" foreground="\4" params="\5" data="\6?
s?<BITONALTILE>\([0-9]*\) \([0-9]*\) \([0-9]*\) \([0-9]*\)[ ]*<S>\(.*\)</S>\(.*\)</BITONALTILE>?<BITONALTILE type="\1" rowpad="\2" background="\3" foreground="\4" params="\5" data="\6"/>?
s?<BITONALTILE>\([0-9]*\) \([0-9]*\) \([0-9]*\) \([0-9]*\)[ ]*<S>\(.*\)</S>\(.*\)?<BITONALTILE type="\1" rowpad="\2" background="\3" foreground="\4" params="\5" data="\6?
#
s?<TILE>\([0-9]*\) \([0-9]*\) \([0-9]*\)<S>\(.*\)</S></TILE>?<TILE type="\1" rowpad="\2" maxint="\3" data="\4" />?
s?<TILE>\([0-9]*\) \([0-9]*\) \([0-9]*\)<S>\(.*\)?<TILE type="\1" rowpad="\2" maxint="\3" data="\4?
#?
s?<LINEINDEX>\(.*\)</LINEINDEX>?<LINEINDEX bundleindex="\1"/>?
#
s?<LINETYPE>\(.*\)</LINETYPE>?<LINETYPE type="\1"/>?
#
s?<LINEWIDTH>\(.*\)</LINEWIDTH>?<LINEWIDTH width="\1"/>?
#
s?<LINECOLR>\(.*\)</LINECOLR>?<LINECOLR k="\1"/>?
#
s?<MARKERINDEX>\(.*\)</MARKERINDEX>?<MARKERINDEX bundleindex="\1"/>?
#
s?<MARKERTYPE>\(.*\)</MARKERTYPE>?<MARKERTYPE type="\1"/>?
#
s?<MARKERSIZE>\(.*\)</MARKERSIZE>?<MARKERSIZE size="\1"/>?
#
s?<MARKERCOLR>\(.*\)</MARKERCOLR>?<MARKERCOLR k="\1"/>?
#
s?<TEXTINDEX>\(.*\)</TEXTINDEX>?<TEXTINDEX bundle="\1"/>?
#
s?<TEXTFONTINDEX>\(.*\)</TEXTFONTINDEX>?<TEXTFONTINDEX font="\1"/>?
#
s?<TEXTPREC><\(.*\)/></TEXTPREC>?<TEXTPREC set="\1"/>?
#
s?<CHAREXPAN>\(.*\)</CHAREXPAN>?<CHAREXPAN factor="\1"/>?
#
s?<CHARSPACE>\(.*\)</CHARSPACE>?<CHARSPACE k="\1"/>?
#
s?<TEXTCOLR>\(.*\)</TEXTCOLR>?<TEXTCOLR k="\1"/>?
#
s?<CHARHEIGHT>\(.*\)</CHARHEIGHT>?<CHARHEIGHT height="\1"/>?
#
s?<CHARORI>\(.* .*\) \(.* .*\)</CHARORI>?<CHARORI up="\1" base="\2"/>?
#
s?<TEXTPATH><\(.*\)/></TEXTPATH>?<TEXTPATH path="\1"/>?
#
s?<TEXTALIGN><\(.*\)/><\(.*\)/>\(.*\) \(.*\)</TEXTALIGN>?<TEXTALIGN h="\1" v="\2" chorizontal="\3" cvertical="\4"/>?
s?<TEXTALIGN><\(.*\)/>\([a-zA-Z]*\) \([0-9]*\) \([0-9]*\)</TEXTALIGN>?<TEXTALIGN h="\1" v="\2" chorizontal="\3" cvertical="\4"/>?
#
s?<CHARSETINDEX>\(.*\)</CHARSETINDEX>?<CHARSETINDEX index="\1"/>?
#
s?<ALTCHARSETINDEX>\(.*\)</ALTCHARSETINDEX>?<ALTCHARSETINDEX index="\1"/>?
#
s?<FILLINDEX>\(.*\)</FILLINDEX>?<FILLINDEX index="\1"/>?
#
s?<INTSTYLE><\(.*\)/></INTSTYLE>?<INTSTYLE style="\1"/>?
#
s?<FILLCOLR>\(.*\)</FILLCOLR>?<FILLCOLR k="\1"/>?
#
s?<HATCHINDEX>\(.*\)</HATCHINDEX>?<HATCHINDEX index="\1"/>?
#
s?<PATINDEX>\(.*\)</PATINDEX>?<PATINDEX index="\1"/>?
#
s?<EDGEINDEX>\(.*\)</EDGEINDEX>?<EDGEINDEX index="\1"/>?
#
s?<EDGETYPE>\(.*\)</EDGETYPE>?<EDGETYPE type="\1"/>?
#
s?<EDGEWIDTH>\(.*\)</EDGEWIDTH>?<EDGEWIDTH width="\1"/>?
#
s?<EDGECOLR>\(.*\)</EDGECOLR>?<EDGECOLR k="\1"/>?
#
s?<EDGEVIS><\(.*\)/></EDGEVIS>?<EDGEVIS set="\1"/>?
#
s?<FILLREFPT>\(.*\)</FILLREFPT>?<FILLREFPT p1="\1"/>?
#
s?<PATTABLE>\([0-9]*\) \([0-9]*\) \([0-9]*\) \([0-9]*\) \([0-9]*\) \(.*\)</PATTABLE>?<PATTABLE pat="\1" nx="\2" ny="\3" maxint="\4" maxcomponent="\5" cellrow="\6"/>?
s?<PATTABLE>\([0-9]*\) \([0-9]*\) \([0-9]*\) \([0-9]*\) \([0-9]*\) \(.*\)?<PATTABLE pat="\1" nx="\2" ny="\3" maxint="\4" maxcomponent="\5" cellrow="\6?
s?<PATTABLE>\([0-9]*\) \([0-9]*\) \([0-9]*\) \(.*\)</PATTABLE>?<PATTABLE pat="\1" nx="\2" ny="\3" cellrow="\4"/>?
#
s?<PATSIZE>\(.*\) \(.*\)</PATSIZE>?<PATSIZE h="\1" w="\2"/>?
#
s?<COLRTABLE>\([0-9]*\), \(.*\)</COLRTABLE>?<COLRTABLE start="\1" directk="\2"/>?
s?<COLRTABLE>\([0-9]*\), \(.*\)?<COLRTABLE start="\1" directk="\2?
#
s?<PSEUDOASF><\(.*\)/></PSEUDOASF>?<PSEUDOASF pseudoasf="\1"/>?
#
s?<PICKID>\(.*\)</PICKID>?<PICKID pick="\1"/>?
#
s?<LINECAP>\(.*\) \(.*\)</LINECAP>?<LINECAP linecap="\1" dashcap="\2"/>?
#
s?<LINEJOIN>\(.*\)</LINEJOIN>?<LINEJOIN join="\1"/>?
#
s?<LINETYPECONT>\(.*\)</LINETYPECONT>?<LINETYPECONT set="\1"/>?
#
s?<LINETYPEINITOFFSET>\(.*\)</LINETYPEINITOFFSET>?<LINETYPEINITOFFSET offset="\1"/>?
#
s?<TEXTSCORETYPE>\(.*\)<\(.*\)/></TEXTSCORETYPE>?<TEXTSCORETYPE scoretype="\1" set="\2"/>?
#
s?<RESTRTEXTTYPE>\(.*\)</RESTRTEXTTYPE>?<RESTRTEXTTYPE type="\1"/>?
#
#s?<INTERPINT>\(.*\) \(.*\) \(.*\) 
#        style="\x"?
#        p1="\x"?
#        p2 CDATA #IMPLIED
#        stages="\x"?
#        stagedesign="\x"?
#        refcolrlist="\x"?
#
s?<EDGECAP>\(.*\) \(.*\)</EDGECAP>?<EDGECAP edgecap="\1" dashcap="\2"/>?
#
s?<EDGEJOIN>\(.*\)</EDGEJOIN>?<EDGEJOIN join="\1"/>?
#
s?<EDGETYPECONT>\(.*\)</EDGETYPECONT>?<EDGETYPECONT set="\1"/>?
#
s?<EDGETYPEINITOFFSET>\(.*\)</EDGETYPEINITOFFSET>?<EDGETYPEINITOFFSET offset="\1"/>?
#
s?<SYMBOLINDEX>\(.*\)</SYMBOLINDEX>?<SYMBOLINDEX index="\1"/>?
#
s?<SYMBOLCOLR>\(.*\)</SYMBOLCOLR>?<SYMBOLCOLR k="\1"/>?
#
s?<SYMBOLSIZE><\(.*\)/>\(.*\) \(.*\)</SYMBOLSIZE>?<SYMBOLSIZE size="\1" height="\2" width="\3"/>?
#
s?<SYMBOLORI>\(.*\) \(.*\)</SYMBOLORI>?<SYMBOLORI up="\1" base="\2"/>?
#
s?<ESCAPE>\(.*\) \(.*\)</ESCAPE>?<ESCAPE identifier="\1" data="\2"/>?
#
s?<MESSAGE><\(.*\)/>\(.*\)</MESSAGE>?<MESSAGE action="\1"/>\2</MESSAGE>?
#
s?<COPYSEG>\(.*\) \(.*\)<\(.*\)/></COPYSEG>?<COPYSEG segid="\1" tm="\2" yn="\3"/>?
#
s?<INHFILTER>\(.*\)<\(.*\)/></INHFILTER>?<INHFILTER elemorgroups="\1" set="\2"/>?
#
s?<SEGTRAN>\(.*\) \(.*\)</SEGTRAN>?<SEGTRAN segid="\1" tm="\2"/>?
#
s?<SEGHIGHL>\(.*\)<\(.*\)/></SEGHIGHL>?<SEGHIGHL segid="\1" set="\2"/>?
#
s?<SEGDISPPRI>\(.*\) \(.*\)</SEGDISPPRI>?<SEGDISPPRI segid="\1" priority="\2"/>?
#
s?<SEGPICKPRI>\(.*\) \(.*\)</SEGPICKPRI>?<SEGPICKPRI segid="\1" priority="\2"/>?
#
s?</S>"?"?
# Fix loose lines of 'data' strings of form 000.00 00.00</S>
s?^\([0-9eE. 	]*\)</S>?\1"/>?
# Change Generation Info
s?<S>Source:Created by IsoDraw 5,CGM Filter ??
s?5.0.</S><S>Date:200209..</S>?<S>Source:Created by CT2XML Filter 0.7 \
2003-05-16</S><S>WARNING: This is prototype XML and is SUBJECT TO CHANGE WITHOUT NOTICE.</S><S>This example is part \
of the webCGM Test Suite Copyright (C) 2002, Lofton Henderson. All Rights Reserved.</S>?
